#!/bin/bash
# monitorMySQL.sh
#
# Reinicia MySQL si el servidor no está funcionando y envía un email al
# usuario informando de dicha eventualidad.
# Conviene programarlo mediante cron para controlar el servidor MySQL

# CONFIGURACION DEL SERVIDOR DE MYSQL #
 
# Usuario root/administrador de MySQL
MUSER="root"
# Contraseña de administrador/root de MySQL
MPASS="password-de-root"
# Servidor MySQL
MHOST="localhost"
# Ubicación del demonio MySQL para servidores Debian/Ubuntu.
# Modificar de acuerdo a su distribución.
MSTART="/etc/init.d/mysql start"
# Email de notificaciones
EMAILID="notificaciones@donde.com"
# path al programa de mail
MAILCMD="$(which mail)"
# path a mysqladmin
MADMIN="$(which mysqladmin)"
 
#### NO CAMBIE NADA DE LA PARTE INFERIOR ####
MAILMESSAGE="/tmp/mysql.fail.$$"
 
# Comprobación del servicio
$MADMIN -h $MHOST -u $MUSER -p${MPASS} ping 2>/dev/null 1>/dev/null
if [ $? -ne 0 ]; then
	echo "" >$MAILMESSAGE
	echo "Error: El servidor MySQL Server no está respondiendo las peticiones de ping">>$MAILMESSAGE
	echo "Hostname: $(hostname)" >>$MAILMESSAGE
	echo "Fecha & Hora: $(date)" >>$MAILMESSAGE
	# Se intenta reiniciar MySQL
	$MSTART>/dev/null
	# Se comprueba su reinicio
	o=$(ps cax | grep -c ' mysqld$')
	if [ $o -eq 1 ]; then
		sMess="MySQL Server reiniciado correctamente"
	else
		sMess="MySQL Server FALLÓ al ser reiniciado"
	fi
	# Notificación vía mail del proceso
	echo "Estado Actual: $sMess" >>$MAILMESSAGE
	echo "" >>$MAILMESSAGE
	echo "*** Email automático generado por $(basename $0) ***" >>$MAILMESSAGE
	echo "*** Por favor, no responda a este email de notificaciones ***" >>$MAILMESSAGE
	# send email
	$MAILCMD -s "MySQL server" $EMAILID < $MAILMESSAGE
else # MySQL está en ejecución por lo que no se hace nada
	:
fi
# Eliminación del fichero de correo temporal
rm -f $MAILMESSAGE
