#!/bin/bash
# monitorDiscos.sh
# Monitoriza el uso de los discos del sistema.
# Si el uso supera un umbral de alerta, informa vía mail al administrador

# Establecer el email de notificaciones
ADMIN="email@notificaciones.com"
# Establecer el nivel de alerta
ALERT=90

df -H | grep -vE '^S.archivos|tmpfs|cdrom' | awk '{ print $5 " " $1 }' | while read output; 
do
  usep=$(echo $output | awk '{ print $1}' | cut -d'%' -f1  )
  partition=$(echo $output | awk '{ print $2 }' )
  if [ $usep -ge $ALERT ]; then
    echo "Disco sobreutilizado \"$partition ($usep%)\" en $(hostname) con fecha $(date)" |
     mail -s "Alerta: Disco sobreutilizado $usep" $ADMIN
  fi
done

