#!/bin/bash
# Cambio de contraseñas por lotes
#
# Fichero con las contraseñas en texto plano para consulta previa
FILE="/root/batch.passwd"
 
# Obtener cuentas de usuarios sin privilegios
# Con ID > 1000
USERS=$(awk -F: '{ if ( $3 > 1000 ) print $1}' /etc/passwd)
 
# Crear fichero de contraseñas aleatorias
echo "Generando fichero, por favor espere..."
 
# Sobreescribir el fichero (puede usar cat > $FILE)
>$FILE
 
for u in $USERS
do
   p=$(pwgen -1 -n 8) # crear password aleatorio
   echo "$u:$p" >> $FILE # guarda la pareja USUARIO:PASSWORD
done
echo ""
echo "Fichero de contraseñas $FILE creado"
echo "Revise el fichero $FILE. Si está de acuerdo ejecute: "
echo "chpasswd < $FILE"
 
# Descomente esta línea para actualizar las contraseñas de modo automático,
# Úselo bajo su responsabilidad. Es preferible comprobar el fichero $FILE primero
# chpasswd < $FILE

