#!/bin/bash
# deteccionIntrusos.sh
# Muestra un informe de intrusiones procesando el fichero auth.log

AUTHLOG=/var/log/auth.log

if [[ -n $1 ]] ; then
	AUTHLOG=$1
	echo "Usando el fichero de Log :" $AUTHLOG
fi

LOG=/tmp/valid.$$.log

#Búsqueda de información
grep -v "invalid" $AUTHLOG > $LOG
users=$(grep "Failed password" $LOG | awk '{ print $(NF-5) }' | sort | uniq)

#Impresión del informe
printf "%-6s|%-10s|%-10s|%-13s|%-33s|%s\n" "Nº#" "Usuario" "Intentos" \
	"Dirección IP" "Host_Mapping" "Rango de Tiempo"
ucount=0;
ip_list="$(egrep -o "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+" $LOG | sort | uniq)"
for ip in $ip_list ; do
	grep $ip $LOG > /tmp/temp.$$.log
	for user in $users; do
		grep $user /tmp/temp.$$.log> /tmp/$$.log
		cut -c-16 /tmp/$$.log > $$.time
		tstart=$(head -1 $$.time);
		start=$(date -d "$tstart" "+%s");
		tend=$(tail -1 $$.time);
		end=$(date -d "$tend" "+%s")
		limit=$(( $end - $start ))
		if [ $limit -gt 120 ] ; then
			let ucount++;
			IP=$(egrep -o "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+" /tmp/$$.log | head -1 );
			TIME_RANGE="$tstart-->$tend"
			ATTEMPTS=$(cat /tmp/$$.log|wc -l);
			HOST=$(host $IP | awk '{ print $NF }' )
			printf "%-5s|%-10s|%-10s|%-13s|%-33s|%-s\n" "$ucount" "$user" \
				"$ATTEMPTS" "$IP" "$HOST" "$TIME_RANGE";
		fi
	done
done
rm /tmp/valid.$$.log /tmp/$$.log $$.time /tmp/temp.$$.log 2> /dev/null

