#!/bin/bash
# backupFTP-sh
# Copia recursivamente todos los ficheros y los sube
# a un servidor FTP remoto
#
# Para usar con cron debe existir el fichero $AUTHFILE
# y contener la siguiente información
# host servidorFTP
# user usuario
# pass contraseña
#

#Parámeros de configuración 
FTP="/usr/bin/ncftpput"
CMD=""
AUTHFILE="/root/.configuracionFTP"
servidor="servidor"
dirRemoto=/
dirLocal=.
 
if [ -f $AUTHFILE ] ; then
  # Usar el fichero para la autenticación
  CMD="$FTP -m -R -f $AUTHFILE $servidor $dirRemoto $dirLocal"
else
  echo "*** Pulse [ CTRL + C ] para acabar***"
  read -p "Introduzca el nombre del servidor FTP : " servidor
  read -p "Introduzca el nombre de usuario : " usuario
  read -s -p "Introduzca la contraseña : " password
  echo ""
  read -p "Introduzca el directorio remoto [/] : " dirRemoto
  read -p "Introduzca el path de directorio a subir [.] : " dirLocal
  [ "$dirRemoto" == "" ] && dirRemoto="/" || :
  [ "$dirLocal" == "" ] && dirLocal="." || :
  CMD="$FTP -m -R -u $usuario -p $password $servidor $dirRemoto $dirLocal"
fi
 
$CMD

