#!/bin/bash
# Driver del depurador

#Comprobación del número de argumentos
if (( $#<1 )) ; then
	echo "Uso: bashdb <script>" >&2
	exit 1
fi

#Tratamiento del fichero original
_original=$1
if [ ! -r $_original ] ; then
	echo "No se puede leer el fichero $_original" >&2
	exit 1
fi

#Conversión de $1 en $0 y ubicación de los argumentos
#de script original
shift

#Creación del fichero modificado
_tmpdir=/tmp
_libdir=.
_modificado=$_tmpdir/bashdb.$$
cat $_libdir/bashdb.pre $_original > $_modificado

#Ejecución del nuevo script
exec bash $_modificado $_libdir $_original "$@"
